Page MenuHomeFreeBSD

Avoid enabling MSI-X if MSI-X is disabled globally.
ClosedPublic

Authored by shurd on Oct 26 2017, 9:17 PM.

Details

Summary

It was reported on the community call that with
hw.pci.enable_msix=0, iflib would enable MSI-X on the device and attempt
to use it, which caused issues. Test the sysctl explicitly and do not
enable MSI-X if it's disabled globally.

Test Plan

Have reporter test, test for regressions on physical and
virtual systems.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

shurd created this revision.Oct 26 2017, 9:17 PM
kbowling accepted this revision.Oct 26 2017, 11:33 PM
This revision is now accepted and ready to land.Oct 26 2017, 11:33 PM
sbruno accepted this revision.Oct 30 2017, 8:18 PM
This revision was automatically updated to reflect the committed changes.
cem added a subscriber: cem.Oct 30 2017, 10:53 PM

Is this really better than just exposing whatever variable hw.pci.enable_msix corresponds to?

shurd added a comment.Oct 31 2017, 2:59 AM
In D12805#266524, @cem wrote:

Is this really better than just exposing whatever variable hw.pci.enable_msix corresponds to?

It's certainly less intrusive. Until I understand exactly why iflib is rewriting PCIM_MSIXCTRL_MSIX_ENABLE in the PCI config register (the comment points to virtualized environments), I want to keep it simple to delete this change if I end up deleting the call to pci_write_config().